using System;
using System.Collections.Generic;
using System.Text;

namespace JonKruger.EnhancedRuleSetDialog
{
    /// <summary>
    /// A sample object that rules will be written against.
    /// </summary>
    public class Order
    {
        // Data Members
        private Guid id;
        private string customer;
        private DateTime orderDate;
        private int discount;
        private int amount;
        private decimal unitPrice;

        // Constructor
        public Order(string customer, int amount, decimal unitPrice)
        {
            this.customer = customer;
            this.amount = amount;
            this.id = Guid.NewGuid();
            this.discount = 0;
            this.unitPrice = unitPrice;
            this.orderDate = DateTime.Now;
        }

        // Methods
        public decimal GetTotalPrice()
        {
            return unitPrice * amount * (1 - (discount / 100M));
        }

        // Properties
        public Guid ID
        {
            get { return id; }
        }

        public decimal UnitPrice
        {
            get { return unitPrice; }
            set { unitPrice = value; }
        }

        [IncludeInRuleSetDialog(RuleSetDialogTextBoxType.Condition)]
        public int Amount
        {
            get { return amount; }
            set { amount = value; }
        }

        public string Customer
        {
            get { return customer; }
            set { customer = value; }
        }

        public DateTime OrderDate
        {
            get { return orderDate; }
            set { orderDate = value; }
        }

        public int Discount
        {
            get { return discount; }
            set { discount = value; }
        }

        [IncludeInRuleSetDialog(RuleSetDialogTextBoxType.ThenOrElse)]
        public void SubmitOrder()
        {
        }

        [IncludeInRuleSetDialog(RuleSetDialogTextBoxType.ThenOrElse)]
        public void CancelOrder()
        {
        }

        private void SamplePrivateMethod()
        {
        }
    }
}
